Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj	(revision 10501)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj	(revision 10502)
@@ -188,5 +188,4 @@
     <Compile Include="Formatters\SymbolicExpressionTreeLatexFormatter.cs" />
     <Compile Include="Interfaces\ILayoutAdapter.cs" />
-    <Compile Include="Interfaces\ILayoutNode.cs" />
     <Compile Include="Interfaces\IReadOnlySymbol.cs" />
     <Compile Include="Interfaces\ISymbolicExpressionGrammar.cs" />
Index: anches/HeuristicLab.EvolutionTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/IFragment.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/IFragment.cs	(revision 10501)
+++ 	(revision )
@@ -1,30 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
-  public interface IFragment : IItem {
-    ISymbolicExpressionTreeNode Root { get; set; }
-    int Length { get; set; }
-    int Index { get; set; }
-    int OldIndex { get; set; }
-  }
-}
Index: anches/HeuristicLab.EvolutionTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ILayoutNode.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ILayoutNode.cs	(revision 10501)
+++ 	(revision )
@@ -1,49 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Collections.Generic;
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
-  public interface ILayoutNode<T> where T : class {
-    ILayoutNode<T> NextLeft { get; }
-    ILayoutNode<T> NextRight { get; }
-    ILayoutNode<T> LeftSibling { get; }
-    ILayoutNode<T> LeftmostSibling { get; }
-
-    ILayoutNode<T> Thread { get; set; }
-    ILayoutNode<T> Ancestor { get; set; }
-    ILayoutNode<T> Parent { get; set; }
-    List<ILayoutNode<T>> Children { get; set; }
-
-    float Mod { get; set; }
-    float Prelim { get; set; }
-    float Change { get; set; }
-    float Shift { get; set; }
-    int Number { get; set; }
-    int Level { get; set; }
-
-    float X { get; set; }
-    float Y { get; set; }
-
-    bool IsLeaf { get; }
-
-    T Content { get; set; }
-  }
-}
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/HeuristicLab.EvolutionTracking.Views-3.4.csproj
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/HeuristicLab.EvolutionTracking.Views-3.4.csproj	(revision 10501)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/HeuristicLab.EvolutionTracking.Views-3.4.csproj	(revision 10502)
@@ -97,7 +97,5 @@
       <DependentUpon>FrequentFragmentsDialog.cs</DependentUpon>
     </Compile>
-    <Compile Include="GenealogyGraphChart.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="GenealogyGraphChart.cs" />
     <Compile Include="GenealogyGraphChart.Designer.cs">
       <DependentUpon>GenealogyGraphChart.cs</DependentUpon>
Index: anches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SymbolicDataAnalysisGenealogyGraphView.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SymbolicDataAnalysisGenealogyGraphView.cs	(revision 10501)
+++ 	(revision )
@@ -1,28 +1,0 @@
-﻿using System.Drawing;
-using System.Linq;
-using System.Windows.Forms;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views;
-using HeuristicLab.EvolutionTracking;
-using HeuristicLab.EvolutionTracking.Views;
-using HeuristicLab.MainForm;
-using HeuristicLab.MainForm.WindowsForms;
-
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
-  [View("GenealogyGraphView")]
-  [Content(typeof(GenealogyGraph), IsDefaultView = false)]
-  public class SymbolicDataAnalysisGenealogyGraphView : GenealogyGraphView {
-    public override void graphChart_GenealogyGraphNodeClicked(object sender, MouseEventArgs args) {
-      base.graphChart_GenealogyGraphNodeClicked(sender, args);
-      var visualNode = (VisualGenealogyGraphNode)sender;
-      var graphNode = (IGenealogyGraphNode<ISymbolicExpressionTree>)visualNode.Data;
-      IFragment<ISymbolicExpressionTreeNode> fragment = null;
-      if (graphNode.InArcs != null)
-        fragment = (IFragment<ISymbolicExpressionTreeNode>)graphNode.InArcs.Last().Data;
-      if (fragment != null) {
-        var treeView = (GraphicalSymbolicExpressionTreeView)viewHost.ActiveView;
-        treeView.HighlightSubtree(fragment.Root, Color.RoyalBlue);
-      }
-    }
-  }
-}