Index: /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/HeuristicLab.Visualization-3.3.csproj
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/HeuristicLab.Visualization-3.3.csproj	(revision 10515)
+++ /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/HeuristicLab.Visualization-3.3.csproj	(revision 10516)
@@ -124,5 +124,5 @@
     <Compile Include="Primitives\Axis.cs" />
     <Compile Include="Primitives\AxisPrimitiveBase.cs" />
-    <Compile Include="Primitives\LabeledPrimitive.cs" />
+    <Compile Include="Primitives\LabeledEllipse.cs" />
     <Compile Include="Primitives\LinearPrimitiveBase.cs" />
     <Compile Include="Primitives\RectangularPrimitiveBase.cs" />
@@ -136,5 +136,5 @@
     <Compile Include="Primitives\Rectangle.cs" />
     <Compile Include="Primitives\SelectionRectangle.cs" />
-    <Compile Include="Primitives\TextPrimitive.cs" />
+    <Compile Include="Primitives\LabeledRectangle.cs" />
     <Compile Include="PropertiesDialog.cs">
       <SubType>Form</SubType>
Index: anches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/HeuristicLab.Visualization-3.3.csproj.user
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/HeuristicLab.Visualization-3.3.csproj.user	(revision 10515)
+++ 	(revision )
@@ -1,22 +1,0 @@
-﻿<?xml version="1.0" encoding="utf-8"?>
-<Project ToolsVersion="4.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
-  <PropertyGroup>
-    <PublishUrlHistory />
-    <InstallUrlHistory />
-    <SupportUrlHistory />
-    <UpdateUrlHistory />
-    <BootstrapperUrlHistory />
-    <ErrorReportUrlHistory />
-    <FallbackCulture>en-US</FallbackCulture>
-    <VerifyUploadedFiles>false</VerifyUploadedFiles>
-    <ProjectView>ProjectFiles</ProjectView>
-  </PropertyGroup>
-  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|AnyCPU'">
-    <StartAction>Program</StartAction>
-    <StartProgram>C:\Users\bburlacu\Desktop\HL-Core\trunk\sources\bin\HeuristicLab 3.3.exe</StartProgram>
-  </PropertyGroup>
-  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|AnyCPU'">
-    <StartAction>Program</StartAction>
-    <StartProgram>C:\Users\bburlacu\Desktop\HL-Core\trunk\sources\bin\HeuristicLab 3.3.exe</StartProgram>
-  </PropertyGroup>
-</Project>
Index: /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LabeledEllipse.cs
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LabeledEllipse.cs	(revision 10516)
+++ /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LabeledEllipse.cs	(revision 10516)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+
+namespace HeuristicLab.Visualization.Primitives {
+  public class LabeledEllipse : Ellipse {
+    public Font Font { get; set; }
+    public string Text { get; set; }
+
+    public LabeledEllipse(IChart chart, PointD lowerLeft, PointD upperRight) : base(chart, lowerLeft, upperRight) { }
+
+    public LabeledEllipse(IChart chart, PointD lowerLeft, PointD upperRight, Pen pen, Brush brush) : base(chart, lowerLeft, upperRight, pen, brush) { }
+
+    public LabeledEllipse(IChart chart, double x1, double y1, double x2, double y2) : this(chart, new PointD(x1, y1), new PointD(x2, y2)) { }
+
+    public override void Draw(Graphics graphics) {
+      base.Draw(graphics);
+      // draw the text in the center of the bounding rectangle4
+      var p = Chart.TransformWorldToPixel(new PointD(LowerLeft.X, LowerLeft.Y));
+      var s = Chart.TransformWorldToPixel(Size);
+      var stringSize = graphics.MeasureString(Text, Font);
+      var fontSize = Font.Size * s.Width / stringSize.Width;
+      if (fontSize > 12) fontSize = 12; // limit maximum font size so that nodes look nicer
+      Font = new Font(Font.FontFamily, fontSize, GraphicsUnit.Pixel);
+      stringSize = graphics.MeasureString(Text, Font);
+      graphics.DrawString(Text, Font, new SolidBrush(Pen.Color), p.X + (s.Width - stringSize.Width) / 2f, p.Y - (s.Height + stringSize.Height) / 2f);
+    }
+  }
+}
Index: anches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LabeledPrimitive.cs
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LabeledPrimitive.cs	(revision 10515)
+++ 	(revision )
@@ -1,32 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-
-namespace HeuristicLab.Visualization.Primitives {
-  // a labeled ellipse is represented by a group of primitives: an ellipse and a label (text primitive)
-  public class LabeledPrimitive : Group {
-    public LabeledPrimitive(IChart chart, RectangularPrimitiveBase ellipse, TextPrimitive textPrimitive)
-      : base(chart) {
-      base.Add(ellipse);
-      base.Add(textPrimitive);
-    }
-  }
-}
Index: /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LabeledRectangle.cs
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LabeledRectangle.cs	(revision 10516)
+++ /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LabeledRectangle.cs	(revision 10516)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+
+namespace HeuristicLab.Visualization.Primitives {
+  public class LabeledRectangle : Rectangle {
+    public Font Font { get; set; }
+    public string Text { get; set; }
+
+    public LabeledRectangle(IChart chart, PointD lowerLeft, PointD upperRight) : base(chart, lowerLeft, upperRight) { }
+
+    public LabeledRectangle(IChart chart, PointD lowerLeft, PointD upperRight, Pen pen, Brush brush) : base(chart, lowerLeft, upperRight, pen, brush) { }
+
+    public LabeledRectangle(IChart chart, double x1, double y1, double x2, double y2) : this(chart, new PointD(x1, y1), new PointD(x2, y2)) { }
+
+    public override void Draw(Graphics graphics) {
+      base.Draw(graphics);
+      // draw the text in the center of the bounding rectangle4
+      var p = Chart.TransformWorldToPixel(new PointD(LowerLeft.X, LowerLeft.Y));
+      var s = Chart.TransformWorldToPixel(Size);
+      var stringSize = graphics.MeasureString(Text, Font);
+      var fontSize = Font.Size * s.Width / stringSize.Width;
+      if (fontSize > 12) fontSize = 12; // limit maximum font size so that nodes look nicer
+      Font = new Font(Font.FontFamily, fontSize, GraphicsUnit.Pixel);
+      stringSize = graphics.MeasureString(Text, Font);
+      graphics.DrawString(Text, Font, new SolidBrush(Pen.Color), p.X + (s.Width - stringSize.Width) / 2f, p.Y - (s.Height + stringSize.Height) / 2f);
+    }
+  }
+}
Index: anches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/TextPrimitive.cs
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/TextPrimitive.cs	(revision 10515)
+++ 	(revision )
@@ -1,48 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Drawing;
-
-namespace HeuristicLab.Visualization.Primitives {
-  public class TextPrimitive : RectangularPrimitiveBase {
-    public Font Font { get; set; }
-    public string Text { get; set; }
-
-    public TextPrimitive(IChart chart, PointD lowerLeft, PointD upperRight) : base(chart, lowerLeft, upperRight) { }
-
-    public TextPrimitive(IChart chart, PointD lowerLeft, PointD upperRight, Pen pen, Brush brush) : base(chart, lowerLeft, upperRight, pen, brush) { }
-
-    public TextPrimitive(IChart chart, double x1, double y1, double x2, double y2) : this(chart, new PointD(x1, y1), new PointD(x2, y2)) { }
-
-    public override void Draw(Graphics graphics) {
-      base.Draw(graphics);
-      // draw the text in the center of the bounding rectangle4
-      var p = Chart.TransformWorldToPixel(new PointD(LowerLeft.X, LowerLeft.Y));
-      var s = Chart.TransformWorldToPixel(Size);
-      var stringSize = graphics.MeasureString(Text, Font);
-      var fontSize = Font.Size * s.Width / stringSize.Width;
-      if (fontSize > 12) fontSize = 12; // limit maximum font size so that nodes look nicer
-      Font = new Font(Font.FontFamily, fontSize, GraphicsUnit.Pixel);
-      stringSize = graphics.MeasureString(Text, Font);
-      graphics.DrawString(Text, Font, new SolidBrush(Pen.Color), p.X + (s.Width - stringSize.Width) / 2f, p.Y - (s.Height + stringSize.Height) / 2f);
-    }
-  }
-}