Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LabeledEllipse.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LabeledEllipse.cs	(revision 10516)
+++ 	(revision )
@@ -1,48 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Drawing;
-
-namespace HeuristicLab.Visualization.Primitives {
-  public class LabeledEllipse : Ellipse {
-    public Font Font { get; set; }
-    public string Text { get; set; }
-
-    public LabeledEllipse(IChart chart, PointD lowerLeft, PointD upperRight) : base(chart, lowerLeft, upperRight) { }
-
-    public LabeledEllipse(IChart chart, PointD lowerLeft, PointD upperRight, Pen pen, Brush brush) : base(chart, lowerLeft, upperRight, pen, brush) { }
-
-    public LabeledEllipse(IChart chart, double x1, double y1, double x2, double y2) : this(chart, new PointD(x1, y1), new PointD(x2, y2)) { }
-
-    public override void Draw(Graphics graphics) {
-      base.Draw(graphics);
-      // draw the text in the center of the bounding rectangle4
-      var p = Chart.TransformWorldToPixel(new PointD(LowerLeft.X, LowerLeft.Y));
-      var s = Chart.TransformWorldToPixel(Size);
-      var stringSize = graphics.MeasureString(Text, Font);
-      var fontSize = Font.Size * s.Width / stringSize.Width;
-      if (fontSize > 12) fontSize = 12; // limit maximum font size so that nodes look nicer
-      Font = new Font(Font.FontFamily, fontSize, GraphicsUnit.Pixel);
-      stringSize = graphics.MeasureString(Text, Font);
-      graphics.DrawString(Text, Font, new SolidBrush(Pen.Color), p.X + (s.Width - stringSize.Width) / 2f, p.Y - (s.Height + stringSize.Height) / 2f);
-    }
-  }
-}
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LabeledRectangle.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LabeledRectangle.cs	(revision 10516)
+++ 	(revision )
@@ -1,48 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Drawing;
-
-namespace HeuristicLab.Visualization.Primitives {
-  public class LabeledRectangle : Rectangle {
-    public Font Font { get; set; }
-    public string Text { get; set; }
-
-    public LabeledRectangle(IChart chart, PointD lowerLeft, PointD upperRight) : base(chart, lowerLeft, upperRight) { }
-
-    public LabeledRectangle(IChart chart, PointD lowerLeft, PointD upperRight, Pen pen, Brush brush) : base(chart, lowerLeft, upperRight, pen, brush) { }
-
-    public LabeledRectangle(IChart chart, double x1, double y1, double x2, double y2) : this(chart, new PointD(x1, y1), new PointD(x2, y2)) { }
-
-    public override void Draw(Graphics graphics) {
-      base.Draw(graphics);
-      // draw the text in the center of the bounding rectangle4
-      var p = Chart.TransformWorldToPixel(new PointD(LowerLeft.X, LowerLeft.Y));
-      var s = Chart.TransformWorldToPixel(Size);
-      var stringSize = graphics.MeasureString(Text, Font);
-      var fontSize = Font.Size * s.Width / stringSize.Width;
-      if (fontSize > 12) fontSize = 12; // limit maximum font size so that nodes look nicer
-      Font = new Font(Font.FontFamily, fontSize, GraphicsUnit.Pixel);
-      stringSize = graphics.MeasureString(Text, Font);
-      graphics.DrawString(Text, Font, new SolidBrush(Pen.Color), p.X + (s.Width - stringSize.Width) / 2f, p.Y - (s.Height + stringSize.Height) / 2f);
-    }
-  }
-}
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/RectangularPrimitiveBase.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/RectangularPrimitiveBase.cs	(revision 10516)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/RectangularPrimitiveBase.cs	(revision 10518)
@@ -40,4 +40,7 @@
       get { return new SizeD(UpperRight.X - LowerLeft.X, UpperRight.Y - LowerLeft.Y); }
     }
+
+    public string Text { get; set; }
+    public Font Font { get; set; }
 
     protected RectangularPrimitiveBase(IChart chart, PointD lowerLeft, PointD upperRight)
@@ -133,4 +136,21 @@
       }
     }
+
+    protected virtual void DrawText(Graphics graphics) {  // draw the text in the center of the bounding rectangle4
+      var p = Chart.TransformWorldToPixel(new PointD(LowerLeft.X, LowerLeft.Y));
+      var s = Chart.TransformWorldToPixel(Size);
+      var stringSize = graphics.MeasureString(Text, Font);
+      var fontSize = Font.Size * s.Width / stringSize.Width;
+      if (fontSize > 12) fontSize = 12; // limit maximum font size so that nodes look nicer
+      Font = new Font(Font.FontFamily, fontSize, GraphicsUnit.Pixel);
+      stringSize = graphics.MeasureString(Text, Font);
+      graphics.DrawString(Text, Font, new SolidBrush(Pen.Color), p.X + (s.Width - stringSize.Width) / 2f, p.Y - (s.Height + stringSize.Height) / 2f);
+    }
+
+    public override void Draw(Graphics graphics) {
+      if (!string.IsNullOrEmpty(Text))
+        DrawText(graphics);
+      base.Draw(graphics);
+    }
   }
 }